package com.handheldgroup.iscandemo;

import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.view.Menu;
import android.view.View;
import android.widget.TextView;

public class MainActivity extends Activity {
	TextView tvScanResult;
	ScannerInterface scanner;
	IntentFilter intentFilter;
	BroadcastReceiver scanReceiver;

	private boolean isContinue = false;

	private static final String RES_ACTION = "android.intent.action.SCANRESULT";

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		tvScanResult = (TextView) this.findViewById(R.id.tv_scan_result);
		initScanner();
	}

	private void initScanner(){
		scanner = new ScannerInterface(this);
		scanner.open();
		//		scanner.enablePlayBeep(true);
		//		scanner.enableFailurePlayBeep(false);
		//		scanner.enablePlayVibrate(true);
		//		scanner.enablShowAPPIcon(false);
		//		scanner.enablShowNoticeIcon(false);
		//		scanner.enableAddKeyValue(1);
		//		scanner.timeOutSet(2);
		//		scanner.intervalSet(10); 
		//		scanner.lightSet(false);
		//		scanner.enablePower(true);
		//		scanner.addSuffix("BBB");
		//		scanner.interceptTrimleft(2); 
		//		scanner.interceptTrimright(3);
		//		scanner.filterCharacter("R");
		//		scanner.SetErrorBroadCast(true);
		//		scanner.lockScanKey();
		scanner.setOutputMode(1);
		//		scanner.resultScan();
		intentFilter = new IntentFilter(RES_ACTION);
		scanReceiver = new ScannerResultReceiver();
		registerReceiver(scanReceiver, intentFilter);
	}

	@Override
	protected void onDestroy() {
		super.onDestroy();
		finishScanner();
	}

	private void finishScanner(){
		scanner.scan_stop();
		unregisterReceiver(scanReceiver);
		scanner.continuousScan(false);
	}

	public void singleScan(View v){
		scanner.scan_start();
	}

	public void continueScan(View v){
		isContinue=!isContinue;
		if(isContinue){
			scanner.continuousScan(true);
		}else{
			scanner.continuousScan(false);
		}
	}

	public void scanStop(View v){
		scanner.scan_stop();
	}

	private class ScannerResultReceiver extends BroadcastReceiver{
		public void onReceive(Context context, Intent intent) {
			if (intent.getAction().equals(RES_ACTION)){
                String scanResult = intent.getStringExtra("value");
				String type = intent.getStringExtra("type");
				byte[] data = intent.getByteArrayExtra("bytedata");
				tvScanResult.append(scanResult + "\n");
			}
		}
	}

	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}
}
